<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_datetime_input($params, &$smarty ){
    
    if( empty($params['field_name']) ){
        return;
    }
    $data = $godz = $min = '';
    
    $field_name = $params['field_name'];
    
    $value    = isset($params['value']) ? $params['value'] : '';
    $disabled = (isset($params['disabled']) && ($params['disabled'] == true));
    $print = true;
    
    
    $data = isset($params['data']) ? $params['data'] : '';
    $czas = isset($params['czas']) ? $params['czas'] : '';

    
    if( !empty($value) && preg_match('/^[0-9]{4}-[0-9]{1,2}-[0-9]{1,2} [0-9]{1,2}:[0-9]{1,2}(:[0-9]{1,2})?$/', $value)){
        list($data, $czas) = explode(' ', $value);
        list($rok, $mies, $dzien)  = explode('-', $data);
        list($godz, $min)  = explode(':', $czas);
    }else{
        if( empty($data) || !check_date($data) ){
            $data = '';
        }
        
        if( !empty($czas) && preg_match('/^[0-9]{1,2}:[0-9]{1,2}(:[0-9]{1,2})?$/', $czas) ){
            list($godz, $min)  = explode(':', $czas);
        }
    }
    
    $godz = intval($godz);
    $min = intval($min);

    $disabled_str = '';
    if( $disabled ){
        $disabled_str = 'disabled="disabled"';
    }

    $str = '<input type="text" class="form" name="'.$field_name.'_date" value="'.$data.'" '.$disabled_str.' id="'.$field_name.'_date_input">'."\n";
    $str .= '
      <input type=button name="'.$field_name.'_date_btn" id="'.$field_name.'_date_btn" value="..." '.$disabled_str.' >
      <script type="text/javascript">
        Calendar.setup({
          inputField    : "future_starting_date_input",
          button        : "future_starting_date_btn",
          ifFormat      : "%Y-%m-%d",
          align         : "Br"
        });
      </script>
    ';

    $str .= '<select name="'.$field_name.'_hours" '.$disabled_str.'>';
    $str .= '<option value="">Godz.</option>';
    for( $i = 0; $i < 24; $i++ ){
        $istr = sprintf('%02d', $i);
        $str .= '<option value="'.$istr.'" '.(( $i == $godz ) ? 'selected' : '').'>'.$istr.'</option>';
    }
    $str .= '</select>';

    $str .= '<select name="'.$field_name.'_minutes" '.$disabled_str.'>';
    $str .= '<option value="" >Min.</option>';
    for( $i = 0; $i < 60; $i += 5 ){
        $istr = sprintf('%02d', $i);
        $str .= '<option value="'.$istr.'" '.(( $i == $min ) ? 'selected' : '').'>'.$istr.'</option>';
    }
    $str .= '</select>';

    if( $print ){
        echo  $str;
    }else{
        return $str;
    }
    
}

?>
