<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */
require_once(INCLUDE_DIR . '/drzewko.class.php' );

function smarty_function_grupy_tree($params, &$smarty){
    static $included_css_js = false;
    if ( !$included_css_js ) {
        $included_css_js  = true;

        $SCRIPT_URL = $smarty->get_template_vars('SCRIPT_URL');

        echo '<link type="text/css" rel="stylesheet" href="'.$SCRIPT_URL.'/jquery/treeview/jquery.treeview.css">'. "\n";
        echo '<script type="text/javascript" src="'.$SCRIPT_URL.'/jquery/jquery.cookie.js"></script>'. "\n";
        echo '<script type="text/javascript" src="'.$SCRIPT_URL.'/jquery/treeview/jquery.treeview.js"></script>' . "\n";
    }

    $ext = ( isset($params['ext']) ) ? !empty($params['ext']) : false;
    $type = ( isset($params['type']) && is_string($params['type']) && in_array(strtolower(substr($params['type'],0,1)), array('k','t'))) ? $params['type'] : 'towary';

    $tree = drzewko::instance($type, $ext );

    echo '<div class="cats">';
    echo '<div class="cat-all">Wszystkie</div>';
    smarty_function_grupyt_ext_print_cats( $tree->items[0]->items, $params );
    echo '</div>';

    if ( !empty($params['id']) ){
        echo '<script type="text/javascript">' . "\n";
        echo '  $("#'.$params['id'].'").treeview({' . "\n";
        echo '      animated: "slow",' . "\n";
        echo '      collapsed: false,' . "\n";
        echo '      persist: "cookie"' . "\n";
        echo '  }); ' . "\n";
        echo '</script>' . "\n";
    }
}

function smarty_function_grupyt_ext_print_cats( $cats, $options = array() ){

    $options = array_merge(array(
        'input' => null,
        'id' => null,
        'disabled' => false,
        'depth' => 0,
        'ext' => 0,
        'selected' => array()
    ), $options);

    if( !is_array($options['selected']) ){
        $options['selected'] = array();
    }
    extract($options);

    $depth = $options['depth'];
    $str_indent = '    ';
    $indent = str_repeat($str_indent, $depth);

    echo '<ul '.( $depth == 0 && $id ? 'id="'.$id.'"' : '' ).'>';
    foreach( $cats as $cat ){
        $endline = "\n";

        echo $indent . '<li>' . $endline;
        if ( $input ) {
            echo $indent . $str_indent . '<label class="'. ($cat->selected || in_array($cat->id, $selected) ? ' selected' : '' ).'" ><input type=checkbox name="'.str_replace(array('$gid', '%gid'), $cat->id, $input).'" value="'.$cat->id.'" '.($cat->selected || in_array($cat->id, $selected) ? ' checked="checked"' : '' ).' style="margin:0"> ' . $cat->nazwa . '</label>' . $endline;
        } else {
            echo $indent . $str_indent . '<a href="'.URL_PATH.'/'.name2url($cat->nazwa). '-g'.$ext.'-'. $cat->id.'.html" class="'. ($cat->selected || in_array($cat->id, $selected) ? ' selected' : '' ).'" >' . $cat->nazwa . '</a>' . $endline;
        }

        if ( !empty( $cat->items ) ){
            $options['depth']++;
            smarty_function_grupyt_ext_print_cats( $cat->items, $options  );
        }
        echo $indent . '</li>' . $endline;
    }
    echo '</ul>';
}

