/**
 * jQuery progress plugin
 *
 * Plugin do obsugi progresbarw koystajcych z Komponentu ProgressbarComponent
 * zapisujcego parametry wykonywanych akcji do pliku w formacie JSON.
 * Plugin generuje gotowy html z progresbarami i obsuguje zapytania ajaxowe.
 * Dostpna jest moliwo definiowania wasnych komunikatw. Naley jednak zachowa
 * format do sprintf().
 *
 * !IMPORTANT do pluginu naley przekaza relatywny adres do akcji generujcej
 * rozpoczcie procesu (zawierajcej $this->Progressbar->start($aData)).
 *
 * @example $('#progressbar_container')
 *          .progress({
 *              urls:{
 *                   start:"allegro/allegro_categories/startUpdate"
 *              }
 *          });
 *
 */
;
(function($){
    /**
     * Selector
     */
    var _this = null;
    /**
     * Elementy html w postaci obiektw
     */
    var _elements = {};
    /**
     * Nazwa pliku procesu
     */
    var _filename = '';
    /**
     * Zmienna odpowiedzialna za obsug setInterval()
     */
    var _interval = null;
    /**
     * Ilo akcji pobierana w pierwszym ajax'ie
     */
    var _actions = 0;
    /**
     * Zmienna przechowujca opcje
     * @todo Jak przekaza opcje do setTime()
     */
    var _options;


    $.fn.ecprogress = function(options)
    {
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        var url_path = (URL_PATH ? URL_PATH : '');
        if( url_path == '/' ) url_path = '';

        options = $.extend(
            true,{
                messages:{
                    info : " %s %s / %s. Czas cakowity: %s ",
                    infoAction :" %s. Czas cakowity: %s ",
                    infoFinished : "Operacja zakoczona pomylnie. Czas cakowity: %s ",
                    infoStopped : "Operacja zostaa anulowana",
                    infoError  : "Wystpiy bdy. Prosz sprbowa jeszcze raz.",
                    buttonExit : "Zamknij",
                    buttonStop : "Stop"
                },
                title: "Processiong...",
                urls:{
                    start: "",
                    stop:  url_path + "/progress.php?stop=1&file=",
                    get: url_path + "/progress.php?file="
                },
                finish: function(){
                    //funkcja wykonywana po zakoczeniu procesu
                }
            }, options || {});



        if( !options.urls.start  ){
            if ( this.is('a') ) {
                options.urls.start = this.attr('href');
            } else if ( this.is('form') ) {
                options.urls.start = this.attr('action');
            }else if ( this.is('input[type=submit]') ) {
                options.urls.start = this.parents('form').attr('action')
            }
        }

        _this = this;
        _options = options;
        appendHtml(options);

        if ( options.start ) {
            if ( !this.data('ecprogressbar.bind') ) {
                this.data('ecprogressbar.bind', true );
                this.bind('ecprogressbar.start', progressRequest)
            }

            this.trigger('ecprogressbar.start');
        } else {
            setUp( options );
        }
    }
    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function appendHtml(options){
        //console.log('appendHtml');

        _elements.dialog = $('<div>');
        _elements.dialog.addClass('ecprogress-container').appendTo('body');
        _elements.dialog.dialog({
            autoOpen: false,
            modal:true,
            width:600,
            height:250,
            closeOnEscape:false,
            resizable:false,
            title: options.title
        });
        /**
         * Kontener
         */
        _elements.div = $('<div>');
        _elements.div.css('display','none');
        _elements.dialog.append(_elements.div);

        /**
        * Gwny kontenter progressbar'u
        */
        _elements.bar_all = $('<span>');
        _elements.bar_all.addClass('ecprogress-bar big');
        _elements.div.append(_elements.bar_all);
        /**
        * Span ze zmieniajc si dugoci
        */
        _elements.progress_all = $('<span>');
        _elements.progress_all.css('width','0%').text('0%');
        _elements.bar_all.append(_elements.progress_all);
        /**
        * Paragraf na komunikaty
        */
        _elements.info_all = $('<p>');
        _elements.div.append(_elements.info_all);

        /**
         * Loader
         */
        _elements.loader = $('<div>');
        _elements.loader.addClass('ecprogress-loading');
        _elements.dialog.append(_elements.loader);
    }
    /**
     * Dodanie dodatkowego progresbaru na podrzdne akcje
     */
    function apendActionBar(){
        //console.log('apendActionBar');

        _elements.bar_current = $('<span>');
        _elements.bar_current.addClass('ecprogress-bar');

        _elements.progress_current = $('<span>');
        _elements.progress_current.css('width','0%').text('0%');
        _elements.bar_current.append(_elements.progress_current);

        _elements.info_current = $('<p>');

        _elements.div.append(_elements.bar_current);
        _elements.div.append(_elements.info_current);
    }
    /**
    *  Rozpoczcie procesu
    */
    function setUp(options){
        var element = _this, eventType = 'click';

        if ( _this.is ('form') ) {
            eventType = 'submit';
        } else if ( _this.is('input[type=submit]') ) {
            element = _this.parents('form');
            eventType = 'submit';
        }

        if ( !this.data('ecprogressbar.setup' ) ) {
            this.data('ecprogressbar.setup', true );

            element.bind( eventType, progressRequest );
        }
    }

    function progressRequest( e ){
        e.preventDefault();

        //_this.fadeOut().remove();

        var form_data = null, ajax_type = 'GET';
        if ( $(this).is('form') ){
            form_data = new Object();

            var n, $form = $( this  ), i = 0;
            var some_data = $form.find("input, select, textarea").map(function(){
                if( $(this).attr('type') == 'checkbox' || $(this).attr('type') == 'radio' ){
                    n = $(this).attr('name');
                    //jesli tablica i nie zaznaczone to aby nie przesyac pustych danych - pomijam
                    if ( n.substr(-2,2) == '[]' && !this.checked ) {
                        return {name: null, value: 0 };
                    }
                    return {name: n, value: this.checked ? $(this).val() : 0 };
                } else {
                    return {name: $(this).attr('name'), value: $(this).val()};
                }
            }).get();

            ajax_type = $form.attr('method');
            if( !ajax_type ){ajax_type = 'GET'}

            for( i = 0; i < some_data.length; i++  ){
                if ( some_data[i].name ) {
                    if ( some_data[i].name.substr(-2, 2) == '[]' ) {
                        n = some_data[i].name.substr( 0, some_data[i].name.length - 2);
                        if ( !form_data[n] ) {
                            form_data[n] = [];
                        }

                        form_data[n].push(some_data[i].value);
                    } else {
                        form_data[some_data[i].name] = some_data[i].value;
                    }
                }
            }

            //return false;
        }

        _elements.dialog.dialog('open');
        $('.ui-dialog-titlebar-close').remove();
        _elements.div.fadeIn('slow');

        $.ajax({
            'url': _options.urls.start,//Pierwszy ajax rozpoczynajcy proces
            'data' : form_data,
            'type' : ajax_type.toUpperCase(),
            'dataType' : 'json',
            'success': function(data){
                if ( typeof(data) == 'string' && data.substring(0,1) == '{' && data.substring(data.length-1) == '}' ) {
                    try{
                        data = eval('(' + data + ')');
                    }catch(e){
                        data = null;
                    }
                }

                if ( !data || !data.filename || !data.actions ) {
                    _elements.dialog.dialog('close');
                    console.log(data);
                    alert('Nieoczekiwana odpowied z serwera: ' + data );

                    return false;
                }

                _elements.loader.hide();
                _filename = data.filename;
                _actions = data.actions;

                if ( _actions > 1 ) {
                    apendActionBar();
                }
                setTime();

                _elements.dialog.dialog( 'option', "buttons", {
                    'Anuluj' : function(){
                        $.getJSON(_options.urls.stop + _filename);//zatrzymanie procesu
                    }
                });
            },
            dataType : "JSON"
        });

        return false;
    }

    /**
     * Ustawienie akcji wywoywanej w interwale czasowym
     */
    function setTime(){
        _interval = setInterval(function(){
            $.ajax({
               'dataType': "json",
               'global' : false,
               'url': _options.urls.get + _filename,//pobieranie informacji o stanie procesu
               'data': null,
               'success':  function(data){
                    if(data){
                        if(data.status=="stopped"){
                            setupExit(_options.messages.infoStopped, data.status);
                        }
                        else if(data.status=="finished"){
                            _elements.progress_all.css('width','100%').text('100%');
                            setupExit(sprintf(_options.messages.infoFinished,data.time), data.status);
                        }else if(data.status=="error"){
                            setupExit(_options.messages.infoError+":<br />"+data.error, data.status);
                        }else if( data.current ){
                            updateBar(data,_options);//jeeli status active aktualizacja progresbarw
                        }
                    }else{
                        clearInterval(_interval);
                    }
                }
            });
        }, 1500);
    }

    /**
    *  Zakoczenie procesu
    */
    function setupExit(message, status){
        _elements.info_all.html(message);
        if ( _actions > 1 ){
            _elements.bar_current.remove();
            _elements.info_current.remove();
        }
        clearInterval(_interval);

        _elements.dialog.dialog( 'option', "buttons", {
            'Zamknij' : function(){
                try{
                    if ( status == 'finished' && _options && typeof(_options.finish) == 'function' ) {
                        _options.finish.call(_elements.dialog);
                    }
                }catch(ex){
                    console.log(ex);
                }

                _elements.dialog.dialog('close');
            }
        });
    }

    function sprintf () {
      //  discuss at: http://locutus.io/php/sprintf/
      // original by: Ash Searle (http://hexmen.com/blog/)
      // improved by: Michael White (http://getsprink.com)
      // improved by: Jack
      // improved by: Kevin van Zonneveld (http://kvz.io)
      // improved by: Kevin van Zonneveld (http://kvz.io)
      // improved by: Kevin van Zonneveld (http://kvz.io)
      // improved by: Dj
      // improved by: Allidylls
      //    input by: Paulo Freitas
      //    input by: Brett Zamir (http://brett-zamir.me)
      //   example 1: sprintf("%01.2f", 123.1)
      //   returns 1: '123.10'
      //   example 2: sprintf("[%10s]", 'monkey')
      //   returns 2: '[    monkey]'
      //   example 3: sprintf("[%'#10s]", 'monkey')
      //   returns 3: '[####monkey]'
      //   example 4: sprintf("%d", 123456789012345)
      //   returns 4: '123456789012345'
      //   example 5: sprintf('%-03s', 'E')
      //   returns 5: 'E00'

      var regex = /%%|%(\d+\$)?([-+'#0 ]*)(\*\d+\$|\*|\d+)?(?:\.(\*\d+\$|\*|\d+))?([scboxXuideEfFgG])/g
      var a = arguments
      var i = 0
      var format = a[i++]

      var _pad = function (str, len, chr, leftJustify) {
        if (!chr) {
          chr = ' '
        }
        var padding = (str.length >= len) ? '' : new Array(1 + len - str.length >>> 0).join(chr)
        return leftJustify ? str + padding : padding + str
      }

      var justify = function (value, prefix, leftJustify, minWidth, zeroPad, customPadChar) {
        var diff = minWidth - value.length
        if (diff > 0) {
          if (leftJustify || !zeroPad) {
            value = _pad(value, minWidth, customPadChar, leftJustify)
          } else {
            value = [
              value.slice(0, prefix.length),
              _pad('', diff, '0', true),
              value.slice(prefix.length)
            ].join('')
          }
        }
        return value
      }

      var _formatBaseX = function (value, base, prefix, leftJustify, minWidth, precision, zeroPad) {
        // Note: casts negative numbers to positive ones
        var number = value >>> 0
        prefix = (prefix && number && {
          '2': '0b',
          '8': '0',
          '16': '0x'
        }[base]) || ''
        value = prefix + _pad(number.toString(base), precision || 0, '0', false)
        return justify(value, prefix, leftJustify, minWidth, zeroPad)
      }

      // _formatString()
      var _formatString = function (value, leftJustify, minWidth, precision, zeroPad, customPadChar) {
        if (precision !== null && precision !== undefined) {
          value = value.slice(0, precision)
        }
        return justify(value, '', leftJustify, minWidth, zeroPad, customPadChar)
      }

      // doFormat()
      var doFormat = function (substring, valueIndex, flags, minWidth, precision, type) {
        var number, prefix, method, textTransform, value

        if (substring === '%%') {
          return '%'
        }

        // parse flags
        var leftJustify = false
        var positivePrefix = ''
        var zeroPad = false
        var prefixBaseX = false
        var customPadChar = ' '
        var flagsl = flags.length
        var j
        for (j = 0; j < flagsl; j++) {
          switch (flags.charAt(j)) {
            case ' ':
              positivePrefix = ' '
              break
            case '+':
              positivePrefix = '+'
              break
            case '-':
              leftJustify = true
              break
            case "'":
              customPadChar = flags.charAt(j + 1)
              break
            case '0':
              zeroPad = true
              customPadChar = '0'
              break
            case '#':
              prefixBaseX = true
              break
          }
        }

        // parameters may be null, undefined, empty-string or real valued
        // we want to ignore null, undefined and empty-string values
        if (!minWidth) {
          minWidth = 0
        } else if (minWidth === '*') {
          minWidth = +a[i++]
        } else if (minWidth.charAt(0) === '*') {
          minWidth = +a[minWidth.slice(1, -1)]
        } else {
          minWidth = +minWidth
        }

        // Note: undocumented perl feature:
        if (minWidth < 0) {
          minWidth = -minWidth
          leftJustify = true
        }

        if (!isFinite(minWidth)) {
          throw new Error('sprintf: (minimum-)width must be finite')
        }

        if (!precision) {
          precision = 'fFeE'.indexOf(type) > -1 ? 6 : (type === 'd') ? 0 : undefined
        } else if (precision === '*') {
          precision = +a[i++]
        } else if (precision.charAt(0) === '*') {
          precision = +a[precision.slice(1, -1)]
        } else {
          precision = +precision
        }

        // grab value using valueIndex if required?
        value = valueIndex ? a[valueIndex.slice(0, -1)] : a[i++]

        switch (type) {
          case 's':
            return _formatString(value + '', leftJustify, minWidth, precision, zeroPad, customPadChar)
          case 'c':
            return _formatString(String.fromCharCode(+value), leftJustify, minWidth, precision, zeroPad)
          case 'b':
            return _formatBaseX(value, 2, prefixBaseX, leftJustify, minWidth, precision, zeroPad)
          case 'o':
            return _formatBaseX(value, 8, prefixBaseX, leftJustify, minWidth, precision, zeroPad)
          case 'x':
            return _formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad)
          case 'X':
            return _formatBaseX(value, 16, prefixBaseX, leftJustify, minWidth, precision, zeroPad)
            .toUpperCase()
          case 'u':
            return _formatBaseX(value, 10, prefixBaseX, leftJustify, minWidth, precision, zeroPad)
          case 'i':
          case 'd':
            number = +value || 0
            // Plain Math.round doesn't just truncate
            number = Math.round(number - number % 1)
            prefix = number < 0 ? '-' : positivePrefix
            value = prefix + _pad(String(Math.abs(number)), precision, '0', false)
            return justify(value, prefix, leftJustify, minWidth, zeroPad)
          case 'e':
          case 'E':
          case 'f': // @todo: Should handle locales (as per setlocale)
          case 'F':
          case 'g':
          case 'G':
            number = +value
            prefix = number < 0 ? '-' : positivePrefix
            method = ['toExponential', 'toFixed', 'toPrecision']['efg'.indexOf(type.toLowerCase())]
            textTransform = ['toString', 'toUpperCase']['eEfFgG'.indexOf(type) % 2]
            value = prefix + Math.abs(number)[method](precision)
            return justify(value, prefix, leftJustify, minWidth, zeroPad)[textTransform]()
          default:
            return substring
        }
      }

      return format.replace(regex, doFormat)
    }

    /**
     * Aktualizacja progresbarw
     */
    function updateBar(data,options){
        //console.log(data);

        var paction = parseInt(data.current.percent);
        var pall = parseInt( paction / parseInt(data.all.actions))+(( data.all.current / data.all.actions)*100);


        _elements.progress_all.css('width',pall+'%').text(pall+'%');
        if(_actions > 1){
            _elements.info_all.html(sprintf(options.messages.info,data.all.name,(data.all.current+1),data.all.actions,data.all.time));
            _elements.progress_current.css('width',paction+'%').text(paction+'%');
            _elements.info_current.html(sprintf(options.messages.infoAction,data.current.name + (data.current.comment ? (': ' + data.current.comment): ''),data.current.time));
        }else{
            _elements.info_all.html(sprintf(options.messages.infoAction,data.current.name + (data.current.comment ? (': ' + data.current.comment): ''),data.current.time));
        }
    }
})(jQuery);