// JavaScript Document

function trans_class( trans_id, step, time,  min, max ){

    if( arguments.length < 1 ){
        alert('Zamaa liczba parametrw przekazana do funkcji!');
        return false;
    }
    
    this.o_trans = document.getElementById(trans_id);

    if( !this.o_trans ){
        alert('Obiekt o identyfikatorze: ' + trans_id + ' nie istnieje!');
        return false;
    }

    this.step = 0.1;
    this.time = 100;
    this.min = 0;
    this.max = 1;
    

    if( arguments.length > 1 ){
        this.step = step;
        if( arguments.length > 2 ){
            this.time = time;
            if( arguments.length > 3 ){
                this.min = min;
                if( arguments.length > 3 ){
                    this.max = max;
                }
            }
        }
    }
    
    if( this.step <= 0  ){
        this.step = 0.1;
    }
    
    if( this.step > 1  ){
        this.step = 0.1;
    }

    this.timeout_id = -1;
    this.current = this.min;
    this.mover = false;
    this.mout = false;
    
    var o_self = this;
    
    if( ie ){
        this.o_trans.onmouseover = function(){
            o_self.trans_ie_inc();
        }

        this.o_trans.onmouseout = function(){
            o_self.trans_ie_dec();
        }
    }else{
        this.o_trans.onmouseover = function(){
            o_self.trans_inc();
        }

        this.o_trans.onmouseout = function(){
            o_self.trans_dec();
        }
    }
}

trans_class.prototype.trans_inc = function(){
    this.mover = true;
    
    if( this.mout ){
        this.mout = false;
        clearTimeout(this.timeout_id);
    }

    var o_self = this;

    this.current += this.step;

    if(this.current > this.max){
        this.current = this.o_trans.style.opacity = this.max;
    }else{
        this.o_trans.style.opacity = this.current;
        this.timeout_id = setTimeout( function(){ o_self.trans_inc(); }, this.time );
    }

}

trans_class.prototype.trans_dec = function(){
    this.mout = true;
    
    if( this.mover ){
        this.mover = false;
        clearTimeout(this.timeout_id);
    }

    var o_self = this;

    this.current -= this.step;

    if(this.current < this.min){
        this.current = this.o_trans.style.opacity = this.min;
    }else{
        this.o_trans.style.opacity = this.current;
        this.timeout_id = setTimeout( function(){ o_self.trans_dec(); }, this.time );
    }


}


trans_class.prototype.trans_ie_inc = function(){

    this.mover = true;
    
    if( this.mout ){
        this.mout = false;
        clearTimeout(this.timeout_id);
    }

    var o_self = this;

    this.current += this.step;

    if(this.current > this.max){
        this.current = this.max;
        this.o_trans.style.filter = "alpha(opacity=" + parseInt(this.max * 100) + ")";
    }else{
        this.o_trans.style.filter = "alpha(opacity=" + parseInt(this.current * 100) + ")";
        this.timeout_id = setTimeout( function(){ o_self.trans_ie_inc(); }, this.time );
    }

}

trans_class.prototype.trans_ie_dec = function(){
    this.mout = true;
    
    if( this.mover ){
        this.mover = false;
        clearTimeout(this.timeout_id);
    }


    var o_self = this;

    this.current -= this.step;

    if(this.current < this.min){
        this.current = this.min;
        this.o_trans.style.filter = "alpha(opacity=" + parseInt(this.min * 100) + ")";
    }else{
        this.o_trans.style.filter = "alpha(opacity=" + parseInt(this.current * 100) + ")";
        this.timeout_id = setTimeout( function(){ o_self.trans_ie_dec(); }, this.time );
    }
}
