/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/

CREATE TABLE WWW_MAGAZYN (
    TOWAR_ID    SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    MAGAZYN_ID  SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    ILOSC       ILOSC_D /* ILOSC_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    REZERWACJA  ILOSC_D /* ILOSC_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    ILOSC_DOST  SLOWNIK_D /* SLOWNIK_D = INTEGER */
);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_MAGAZYN_ALL_IND ON WWW_MAGAZYN (TOWAR_ID, MAGAZYN_ID, ILOSC_DOST);
CREATE INDEX WWW_MAGAZYN_ILOSC_DOST_IND ON WWW_MAGAZYN (ILOSC_DOST);
CREATE INDEX WWW_MAGAZYN_ILOSC_IND ON WWW_MAGAZYN (ILOSC);
CREATE INDEX WWW_MAGAZYN_MAGAZYN_ID_IND ON WWW_MAGAZYN (MAGAZYN_ID);
CREATE UNIQUE INDEX WWW_MAGAZYN_PK ON WWW_MAGAZYN (TOWAR_ID, MAGAZYN_ID);
CREATE INDEX WWW_MAGAZYN_REZERWACJA_IND ON WWW_MAGAZYN (REZERWACJA);
CREATE INDEX WWW_MAGAZYN_TOWAR_ID_IND ON WWW_MAGAZYN (TOWAR_ID);


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, INSERT, UPDATE, DELETE ON WWW_MAGAZYN TO WWW_ROLE;