<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {make_btn} function plugin
 *
 * File:       function.make_url.php<br>
 * Type:       function<br>
 * Name:       make_url<br>
 * Date:       2007-12-06<br>
 * Purpose:    Prints out a list of checkbox input types<br>
 * Input:<br>
 *           - adres      (required) - string default ""
 *           - parametry  (optional) - string default array()
 * Examples:
 * <pre>
 * {make_btn napis="Przycisk" output="index.php"}
 * {make_btn napis="Przycisk" output="#" onclick="document.forms[0].submit();" style="color: red;"}
 * </pre>
 * @author     Jarek Kotowski <jarek@solution-4u.com>
 * @version    1.0
 * @param array
 * @param Smarty
 * @return string
 */
function smarty_function_make_url($params, &$smarty){

    $query_separator      = URL_QUERY_SEPARATOR;
    $arg_separator        = URL_ARG_SEPARATOR;
    $key_value_separator  = URL_KEY_VAL_SEPARATOR;

    $url_query = '';

    $adres = $params['adres'];

    unset( $params['adres'] );
    if ( strpos($adres, '?') !== false ) {
        foreach($params as $param_name => $param_value) {
            $url_query .= '&amp;' . $param_name .'='. urlencode($param_value) ;
        }
    } else {
        foreach($params as $param_name => $param_value) {
            //if( !empty($param_value) )
                $url_query .= str_replace('_', '-', $arg_separator) . (( $param_name != '_' )? $param_name . $key_value_separator : '' ) . $param_value;
        }
    }

    return $adres . $url_query;

}

?>
